
\chapter{General information}

\section{Somewhere Module}
The \emph{Somewhere2} application is developped using a modular architecture, where
each part of the application is contained in a Somewhere Module. \\
Some of these modules are automatically loaded by Somewhere because 
they are core modules. \\
This is the list of \emph{Somewhere2} core modules :
\begin{itemize}
 \item swr.baseApp
 \item swr.baseI
 \item swr.cli
 \item swr.ui
\end{itemize}
	
Other modules are loaded if the user want to use them 
(they can be choosen to be loaded at compilation time). \\
Each module has a specific purpose. These are the modules developped 
when this manual was written :
\begin{description}
 \item[swr.communication] This module contains abstract routines 
	to create a peer in a P2P network, which can send and receive messages
	from its neighbors.
 \item[swr.communication.jxta] This module contains an implementation of a
	P2P system using the Java framework JXTA. This module
	requires swr.communication to work.
 \item[swr.communication.shoal] This module contains an implementation of a
	P2P system using the Shoal framework. This module
	requires swr.communication to work.
 \item[swr.communication.jgroups] This module contains an implementation of a
	P2P system using the Jgroups framework. This module
	requires swr.communication to work.
 \item[swr.plogic.distributed] Uses the \emph{IASI Libs} propositionnal solver and
	the \emph{swr.communication} module, working as a distributed P2P Inference System.
 \item[swr.plogic.distributed.inconsistency] Extends the \emph{swr.plogic.distributed} module
	in order to handle inconsistency during the distributed calculus.
 \item[swr.benchmark] Uses the \emph{swr.communication} module in order to simulated a 
	distributed P2P Inference System.
 \item[swr.ui.console] A console Shell User Interface
	where the user can enter commands to control Somewhere.
\end{description}

More information about the \emph{Somewhere2} architecture can be found on the \emph{Somewhere2 Developper's Manual}.

\section{Configuration Files}
\emph{Somewhere2} configuration system is designed to support its modular architecture. \\
The information is gathered in an xml configuration file, where there are parent balises
corresponding to each somewhere module configuration, and child balises which corresponds
to configuration keys. \\
It is also possible to change dynamically the configuration of a module by loading a
new configuration file, or by a user interface command. It is also possible to
split the configuration over several xml files.


\section{User Interface}
An running \emph{Somewhere2} program can be user-accessed by several ways: 
\begin{description}
	\item[by the command line] You can send commands to be executed
		by a locally executed \emph{Somewhere2} program.
	\item[by the integrated console shell] Where you can enter commands
		with an interface that looks like a console shell.
	\item[by others ways] If you have loaded a user-interface module.
\end{description}
All user interfaces share the same commands set which can be executed,
so, for example, you can do the same thing on the command line and 
on the integrated shell.


\section{Ontologies and distributed propositional solver}
One of the \emph{Somewhere2} modules contains a propositional solver : it is
named the {\em swr.plogic.distributed} module. \\
This solver is meant to work in the distributed P2P environment that
the \emph{Somewhere2} module {\em communication} offers. \\
The design of the {\em plogic} module is similar to the solver part in 
Somewhere-Adjiman.


